/*
 *	main.c
 *
 *	o[ṼASY
 *
 *	* Sat Nov 04 04:49:49 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/*{{2007/07/23 P/EMU 48MHzΉΉ*/
	bP0_P0D_P07D = 1;
	/*}}2007/07/23 P/EMU 48MHzΉΉ*/

	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#include "texture.h"
#undef TEXTURE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#include "texture.h"
#undef TEXTURE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	board_test = BoardTest_new();
	/*{{OύX\*/
	board_test->ai->type = AI_TYPE_NEGASCOUT;
	board_test->ai->presearch_depth = 3;
	board_test->ai->normal_depth    = 5;
	board_test->ai->wld_depth       = 9;
	board_test->ai->perfect_depth   = 7;
	/*}}OύX\*/
	board_test->player = 1;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			update();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result;
	int x;
	int y;
	int sel = 5; /* ԂŁACPUvC[IƂ */

	for(;;) {
		schedule();
		surface_clear(&surface, 0);

		/* X^[g?I? */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ^CgB */
		{
			x = (DISP_X - (10 * 6 + 1)) / 2;
			y = 10;
			render_line(&render, 0, y -  2, DISP_X, y -  2, 2);
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 25, 1);
			render_line(&render, 0, y + 24, DISP_X, y + 24, 2);
			render_printf_framed(&render, x, y, 0x80, 0x230, " o[V ");
			y += 12;
			render_printf_framed(&render, x, y, 0x80, 0x230, "ASY");
		}

		if(sel > 0) {
			if(joy & TRG_UP) {
				sel--;
			}
		}
		if(sel < 5) {
			if(joy & TRG_DN) {
				sel++;
			}
		}
		x = (DISP_X - (10 * 7)) / 2;
		y = 42;

		/* ASYB */
		{
			static const char* const item[] = {
				"megl@",
				"`lphaaet@",
				"megarcou@",
			};
			render_printf(&render, x, y, 0x80, 2 + (sel == 0),
				item[board_test->ai->type]);
			if(sel == 0) {
				if(board_test->ai->type > 0) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->ai->type--;
					}
				}
				if(board_test->ai->type < 2) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->ai->type++;
					}
				}
			}
			y += 11;
		}

		/* Oǎ萔B */
		{
			render_printf(&render, x, y, 0x80, 2 + (sel == 1),
				"Oǎ萔%2d",
				board_test->ai->presearch_depth);
			if(sel == 1) {
				if(board_test->ai->presearch_depth > 1) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->ai->presearch_depth--;
					}
				}
				if(board_test->ai->presearch_depth < 3) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->ai->presearch_depth++;
					}
				}
				if(board_test->ai->presearch_depth > board_test->ai->normal_depth) {
					board_test->ai->normal_depth = board_test->ai->presearch_depth;
				}
			}
			y += 11;
		}

		/* Tǎ萔B */
		{
			render_printf(&render, x, y, 0x80, 2 + (sel == 2),
				"Tǎ萔%2d",
				board_test->ai->normal_depth);
			if(sel == 2) {
				if(board_test->ai->normal_depth > 1) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->ai->normal_depth--;
					}
				}
				if(board_test->ai->normal_depth < 5) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->ai->normal_depth++;
					}
				}
				if(board_test->ai->normal_depth < board_test->ai->presearch_depth) {
					board_test->ai->presearch_depth = board_test->ai->normal_depth;
				}
			}
			y += 11;
		}

		/* Kǎc萔B */
		{
			render_printf(&render, x, y, 0x80, 2 + (sel == 3),
				"Kǎc萔%2d",
				board_test->ai->wld_depth);
			if(sel == 3) {
				if(board_test->ai->wld_depth > 1) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->ai->wld_depth--;
					}
				}
				if(board_test->ai->wld_depth < 15) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->ai->wld_depth++;
					}
				}
				if(board_test->ai->wld_depth < board_test->ai->perfect_depth) {
					board_test->ai->perfect_depth = board_test->ai->wld_depth;
				}
			}
			y += 11;
		}

		/* Sǎc萔B */
		{
			render_printf(&render, x, y, 0x80, 2 + (sel == 4),
				"Sǎc萔%2d",
				board_test->ai->perfect_depth);
			if(sel == 4) {
				if(board_test->ai->perfect_depth > 1) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->ai->perfect_depth--;
					}
				}
				if(board_test->ai->perfect_depth < 13) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->ai->perfect_depth++;
					}
				}
				if(board_test->ai->perfect_depth > board_test->ai->wld_depth) {
					board_test->ai->wld_depth = board_test->ai->perfect_depth;
				}
			}
			y += 11;
		}

		/* CPUAvC[B */
		{
			static const char* const item[] = {
				":CPU  :CPU",
				":You  :CPU",
				":CPU  :You",
			};
			render_printf(&render, x, y, 0x80, 2 + (sel == 5),
				item[board_test->player]);
			if(sel == 5) {
				if(board_test->player > 0) {
					render_printf(&render,  1, y, 0x80, 3, "<");
					if(joy & TRG_LF) {
						board_test->player--;
					}
				}
				if(board_test->player < 2) {
					render_printf(&render, 82, y, 0x80, 3, ">");
					if(joy & TRG_RI) {
						board_test->player++;
					}
				}
			}
		}

		/* vvgB */
		if(now % SEC(1.0) < SEC(0.5)) {
			x = 1;
			y = 116;
			render_printf(&render, x, y, 0x80, 3, "[A]Jn [SEL]I");
		}
	}

	return result;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	BoardTest_main(board_test);
}
